'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

exports.toArray = toArray;
exports.getActiveIndex = getActiveIndex;
exports.getActiveKey = getActiveKey;
exports.getPropertyName = getPropertyName;
exports.getTransformPropertyName = getTransformPropertyName;
exports.getTransitionPropertyName = getTransitionPropertyName;
exports.isVertical = isVertical;
exports.getTranslateByIndex = getTranslateByIndex;
exports.assign = assign;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function toArray(children) {
  if (Array.isArray(children)) {
    return children;
  }
  var c = [];
  _react2["default"].Children.forEach(children, function (child) {
    return c.push(child);
  });
  return c;
}

function getActiveIndex(children, activeKey) {
  var c = toArray(children);
  for (var i = 0; i < c.length; i++) {
    if (c[i].key === activeKey) {
      return i;
    }
  }
  return -1;
}

function getActiveKey(children, index) {
  var c = toArray(children);
  return c[index].key;
}

var names = {};

function getPropertyName(name) {
  var _transforms;

  if (!window.getComputedStyle) {
    return false;
  }
  if (names[name] !== undefined) {
    return names[name];
  }
  var Name = name.charAt(0).toUpperCase() + name.substring(1);
  var el = document.createElement('p');
  var transforms = (_transforms = {}, (0, _defineProperty3["default"])(_transforms, 'webkit' + Name, '-webkit-' + name), (0, _defineProperty3["default"])(_transforms, 'ms' + Name, '-ms-' + name), (0, _defineProperty3["default"])(_transforms, 'Moz' + Name, '-moz-' + name), (0, _defineProperty3["default"])(_transforms, '' + name, '-webkit-' + name), _transforms);
  var transformPropertyName = '';
  // Add it to the body to get the computed style.
  document.body.insertBefore(el, null);
  for (var t in transforms) {
    if (el.style[t] !== undefined) {
      transformPropertyName = t;
    }
  }
  document.body.removeChild(el);
  return transformPropertyName;
}

function getTransformPropertyName() {
  return getPropertyName('transform');
}

function getTransitionPropertyName() {
  return getPropertyName('transition');
}

function isVertical(tabBarPosition) {
  return tabBarPosition === 'left' || tabBarPosition === 'right';
}

function getTranslateByIndex(index, tabBarPosition) {
  var transformName = arguments.length <= 2 || arguments[2] === undefined ? getTransformPropertyName() : arguments[2];

  var translate = isVertical(tabBarPosition) ? 'translateY' : 'translateX';
  return (0, _defineProperty3["default"])({}, transformName, translate + '(' + -index * 100 + '%) translateZ(0)');
}
function assign(o1, o2) {
  for (var i in o2) {
    if (o2.hasOwnProperty(i)) {
      o1[i] = o2[i];
    }
  }
}